REST API Custom Properties Import V1

This source is used to custom properties import in Quant. Input and output format is JSON.

Use the  Automatic Tasks section to create and set up an import. Once created, the task list will have the ID that you pass in the request URL.

Automatic Task
Task ID
  • Settings

Before using the API, you must edit the following attributes in the Settings tab:

  • Check the Enabled attribute to enable the task.
  • In the Users with API Access Permission, select one or more users with the Robot role who will have permission to run the task.
  • Select the entity for which the optional property should be created in the Custom Property for Import attribute.
  • The Custom Property Type Mapping allows you to configure the mapping for individual field types, such as decimal, date or single-line text.
  • In the Custom Properties Attribute Mapping, select the attributes to import and optionally modify their JSON keys.
  • We also recommend filling in the Emails for Notifications field, where you can enter one or more email addresses to which error notifications will be sent.
  • Attributes
Atribute
Description
Type
Enabled
Specifies whether the automated task is active and data can be sent through it.
yes/no
Title
Custom name of the automated task.
text
Description
Custom description of the automatic task function.
formatted text
Notes
Notes.
long text
Emails for Notifications

One or more email addresses to which emails with error conditions will be sent.

list of strings
Users with API Access Permission
Users with the Robot role who are authorized to run the task.
list of users
Custom Property for Import
This specifies the entity for which the custom property should be created. For example, this could be a product.
selection
Custom Property Type Mapping
This is an attribute of the custom property type, which is used to map individual types of custom property, such an a decimal number, a date or a single line of text
complex type
Delay in Seconds before Retrying
This is the number of seconds that the client should wait before retrying the import in the event of a long queue of requests to the server.
whole number
Custom Properties Attribute Mapping
A mapping containing an entry for each attribute to be imported.
complex typ
Measure Unit
Measure unit such as cm, mm etc.
selection
Date Format
Date entry format, eg 31.12.19.
selection
Date and Time Format
Date and time entry format, eg 19.12.31 23:59:59
selection
List Item Separator
This is the separator for items in a list of values.
selection


Settings
  • Request
/v1/import/custom-properties/{task_id}
Parameter
Value
URL
?debug added to the URL will also display warnings in the response. Without it, only errors are listed.
Header
Accept: application/json
Header
Content-type: application/json
Header

Authorization: Bearer  <TOKEN>

TOKEN is received via /authenticate (see Login).

Method
POST


The content of the request is an array of JSON objects containing the keys defined in the Custom Properties Attribute Mapping setting. 

It is important that the request complies with JSON standards. Defined, for example, here. Please send numerical attribute values without quotation marks, see example.

  • Response
Key
Value
Status
A string describing the final state of the import.
  • SUCCESS = error-free import process
  • PARTIAL_SUCCESS = import completed but generated one or more warnings
  • FAILURE = one or more errors occurred during the import
Warnings
It is optional, ie. is included only if the ?debug parameter is in the URL and the import generated at least one warning.
List of warning strings.
Errors
Optional - included only if the import generated at least one error.
List of warning strings.
Total Lines
Optional - is included only if the import did not end with the status "FAILURE"
Number of records on input.
Duplicated Products
Optional - is included only if the import did not end with the status "FAILURE"
The number of records that were skipped because this product was already imported in the same request.
Ignored Products
By default, if the import cannot find a live product with specified ID, it searches the deleted products list instead. If a deleted product is found, it is restored. Enabling this option means that deleted products are ignored instead of being restored.


  • Status Codes
Status
Value
200 OK
Import successful with "SUCCESS" or "PARTIAL_SUCCESS" status. The response may contain warnings or minor errors.
400 Bad Request
Incorrect task settings or incorrect request.
401 Unauthorized
The authorization token is invalid, or the user who is logged on with the token does not have permission to run this task.
404 Not Found
No task was found with the ID specified in the URL.
500 Internal Server Error

A critical server-side error occurred during the import.

503 Service Unavailable

The task is already running. Retry launching the task after count of seconds given in response header Retry-After.


  • Latest Logs

In Quant, in addition to task settings, you can also view records of individual imports, including statistics, errors, and warnings.

Latest Logs

We can view the details of a specific record by selecting it and clicking the Download Files button.

Record Details


  • Request

 curl -X POST --location "https://[YOUR_COMPANY].iquant.eu/v1/import/custom-properties/959977?debug" \

    -H "Authorization: Bearer ywJqq25pXO6oaCPqgEAiTioBVwM8Ih2kOwzzd3eWK3R2oDSA5n" \
    -H "Accept: application/json" \
    -H "Content-Type: application/json" \
    -H "Cache-Control: no-cache" \
-d "[ {"id":"num1","name":"Number 1","type":"num", "store_specific":true, "group": "REST"},
        {"id":"date1","name":"Date name 1","type":"Date", "store_specific":false, "group": "Date Group"},
{"id":"date2", "name": "Date name 2", "type":"Date"},
{"name":"Text name","type":"text", "store_specific":true, "group": "REST"}
]"
  • Response

{
  "Status": "SUCCESS", 
  "Total Lines": 4,
  "Duplicated Products": 0,
  "Ignored Products": 0
}